## fftw3 3.3.3

=== debian/changelog ===
fftw3 (3.3.3-7ubuntu3) trusty; urgency=medium

  * Add missing build-essential test dependency for the "build" autopkgtest.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 25 Feb 2014 18:15:11 +0100

fftw3 (3.3.3-7ubuntu2) trusty; urgency=medium

  * Don't configure with --enable-neon on AArch64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Jan 2014 13:53:13 +0100

fftw3 (3.3.3-7ubuntu1) trusty; urgency=medium

  * Merge with Debian; remaining changes:
    - Remove the mpi packages not suitable for main.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Jan 2014 13:14:57 +0100

fftw3 (3.3.3-7) unstable; urgency=low

  * restrict architectures of long dependency of libfftw3-3 (Closes: #710890)
  * enable runtime detected sse2 and avx on x32
  * enable long and quad precision on x32

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sun, 27 Oct 2013 13:48:27 +0100

fftw3 (3.3.3-6) unstable; urgency=low

  * wisdom-manpage.patch: fix wrong example in manpage
  * make transitional libfftw3-3 depend on libfftw3-long3 for compatibility
    with unpackaged software (Closes: #710890)
  * fix-fftw-wisdom-to-conf.patch: fix tool not accepting wisdom files
  * add autopkgtests for tools and basic usage
  * enable runtime detected neon support for arm64

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sat, 26 Oct 2013 17:05:33 +0200

fftw3 (3.3.3-5ubuntu1) saucy; urgency=low

  * Merge with Debian; remaining changes:
    - Remove the mpi packages not suitable for main.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Sep 2013 15:43:41 +0200

fftw3 (3.3.3-5) unstable; urgency=low

  * stop building quad library on ia64, really Closes: #709168

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Wed, 22 May 2013 19:04:32 +0200

fftw3 (3.3.3-4) unstable; urgency=low

  * texinfo5-compat.patch: fix ftbfs with texinfo5
  * add generated html files to extended-diff-ignore
  * build depend and use gcc-4.8 on ia64, fixes ICE in quad (Closes: #709168)

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Tue, 21 May 2013 20:37:52 +0200

fftw3 (3.3.3-3) unstable; urgency=low

  * Upload to unstable
  * add powerpcspe to libfftw3-long3 architecture (Closes: #702863)
    Thanks Roland Stigge for the report
  * use canonical Vcs field urls
  * re-add Provides: fftw3, required by mffm-fftw and libaudiomask

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sat, 04 May 2013 12:31:09 +0200

fftw3 (3.3.3-2ubuntu1) raring; urgency=low

  * Merge with Debian (LP: #1088051), remaining changes:
    - remove the mpi packages not suitable for main

 -- Julian Taylor <jtaylor@ubuntu.com>  Mon, 10 Dec 2012 10:30:19 +0100

fftw3 (3.3.3-2) experimental; urgency=low

  * restrict architectures of libfftw3-dev dependencies on -quad3 and -long3
  * don't build docs in parallel, sometimes leads to broken faq

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sun, 09 Dec 2012 15:31:07 +0100

fftw3 (3.3.3-1ubuntu1) raring; urgency=low

  * Merge with Debian (LP: #1088051), remaining changes:
    - remove the mpi packages not suitable for main

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sun, 09 Dec 2012 00:33:51 +0100

fftw3 (3.3.3-1) experimental; urgency=low

  * New upstream release (Closes: #694401)
  * split the precision libraries into separate packages:
    - libfftw3-single3: single precision
    - libfftw3-double3: double precision
    - libfftw3-long3: long double precision
    - libfftw3-quad3: quad precision (Closes: #691677)
    - libfftw3-3: transitional package depending on single and double
    - libfftw3-dev: depends on all precisions
    - libfftw3-mpi3: continues to contain all precisions
  * Acknowledge NMU, thanks Ansgar Burchardt
  * add debian/source/extended-diff-ignore to ignore generated files
  * add hardening flags to long long test so build log check does not complain
  * drop --with-gcc-arch configure flag, has no effect anymore
  * use dh-autoreconf
  * Bump to standards 3.9.4, no changes required
  * add .NOTPARALLEL to debian/rules
  * escape minus signs in 03_fix_manpages.diff
  * pkg-config.patch: move -lm to Libs.private
  * delete obsolete and disabled 10_uptodate_configure.diff
  * don't install tests as examples, they are not good examples and won't
    compile without files in the source tree

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sat, 01 Dec 2012 19:12:03 +0100

=== debian/control ===
Source: fftw3
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Paul Brossier <piem@debian.org>,
           Julian Taylor <jtaylor.debian@googlemail.com>
Build-Depends: chrpath,
               debhelper (>=7.0.0),
               dh-autoreconf,
               dpkg (>= 1.16.0),
               gfortran,
               texinfo
Build-Depends-Indep: ghostscript (>> 8.63), transfig
Vcs-Git: git://anonscm.debian.org/debian-science/packages/fftw3.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/fftw3.git
Homepage: http://fftw.org
Standards-Version: 3.9.4
XS-Testsuite: autopkgtest

Package: libfftw3-3
Architecture: any
Depends: libfftw3-double3 (=${binary:Version}),
         libfftw3-long3 (=${binary:Version}) [amd64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe s390 s390x sparc x32],
         libfftw3-single3 (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Provides: fftw3
Replaces: fftw3
Conflicts: fftw3
Multi-Arch: same
Section: oldlibs
Priority: extra
Description: Library for computing Fast Fourier Transforms
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast.
 This package is a transitional package depending on the packages containing
 the single and double precision libraries.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-single3
Architecture: any
Pre-Depends: multiarch-support
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Multi-Arch: same
Replaces: libfftw3-3 (<< 3.3.3-1)
Breaks: libfftw3-3 (<< 3.3.3-1)
Description: Library for computing Fast Fourier Transforms - Single precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for single precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-double3
Architecture: any
Pre-Depends: multiarch-support
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Multi-Arch: same
Replaces: libfftw3-3 (<< 3.3.3-1)
Breaks: libfftw3-3 (<< 3.3.3-1)
Description: Library for computing Fast Fourier Transforms - Double precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for double precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-long3
Architecture: amd64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe s390 s390x sparc x32
Pre-Depends: multiarch-support
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Multi-Arch: same
Replaces: libfftw3-3 (<< 3.3.3-1)
Breaks: libfftw3-3 (<< 3.3.3-1)
Description: Library for computing Fast Fourier Transforms - Long precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for long double precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-quad3
Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 x32
Pre-Depends: multiarch-support
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libfftw3-bin, libfftw3-dev
Multi-Arch: same
Description: Library for computing Fast Fourier Transforms - Quad precision
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the shared library
 for quad precision transforms.
 .
 To get the static library and the header files, you need to install
 libfftw3-dev. For documentation, see libfftw3-doc.

Package: libfftw3-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Replaces: libfftw3-dev (<< 3.3.2-1)
Breaks: libfftw3-dev (<< 3.3.2-1)
Description: Library for computing Fast Fourier Transforms - Tools
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast.
 .
 This package contains the wisdom management tools.

Package: libfftw3-dev
Architecture: any
Section: libdevel
Depends: libfftw3-bin (=${binary:Version}),
         libfftw3-double3 (=${binary:Version}),
         libfftw3-long3 (=${binary:Version}) [amd64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe s390 s390x sparc x32],
         libfftw3-quad3 (=${binary:Version}) [amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 x32],
         libfftw3-single3 (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: fftw3-dev
Replaces: fftw3-dev
Conflicts: fftw3-dev
Multi-Arch: same
Description: Library for computing Fast Fourier Transforms - development
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 This package contains the header files and static libraries.
 For documentation, see libfftw3-doc.

Package: libfftw3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libfftw3-3
Provides: fftw3-doc
Replaces: fftw3-doc
Conflicts: fftw3-doc
Description: Documentation for fftw version 3
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the documentation for
 the fftw3 library.

Package: libfftw3-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libfftw3-dev (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Library for computing Fast Fourier Transforms - debug symbols
 The FFTW library computes Fast Fourier Transforms (FFT) in one or more
 dimensions. It is extremely fast. This package contains the statically linked
 library, header files and test programs.
 .
 This package contains debug packages.
 .
 For documentation, see libfftw3-doc.

=== debian/rules ===
#!/usr/bin/make -f

ARCHITECTURE := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

ifeq (libfftw3-quad3,$(findstring libfftw3-quad3, $(shell dh_listpackages)))
QUAD := quad
else
QUAD :=
endif
ifeq (libfftw3-long3,$(findstring libfftw3-long3, $(shell dh_listpackages)))
LONG := long
else
LONG :=
endif
PREC := single double $(LONG) $(QUAD)

# old configure stuff needs a --target
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  archconfflags := $(archconfflags) --build $(DEB_HOST_GNU_TYPE)
else
  archconfflags := $(archconfflags) --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

#--enable-k7             enable AMD K7 optimizations, including 3dNow! (single precision)
#--enable-sse            enable SSE optimizations (single precision only)
#--enable-sse2           enable SSE2 optimizations (double precision only)
#--enable-altivec        enable Altivec optimizations (single precision only)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
ifneq (,$(filter $(ARCHITECTURE), i386 amd64 x32))
	archconfflags_single := --enable-sse --enable-avx
	archconfflags_double := --enable-sse2 --enable-avx
endif
# no avx support in debian yet see #674760
ifneq (,$(filter $(ARCHITECTURE), kfreebsd-i386 kfreebsd-amd64))
	archconfflags_single := --enable-sse
	archconfflags_double := --enable-sse2
endif
ifeq ($(ARCHITECTURE), powerpc)
	archconfflags_single := --enable-altivec
endif
ifneq (,$(filter $(ARCHITECTURE), armhf))
	archconfflags_single := --enable-neon
endif
endif

ifneq (,$(findstring nog77,$(DEB_BUILD_OPTIONS)))
	archconfflags := $(archconfflags) F77="gfortran" 
else
	archconfflags := $(archconfflags) F77="gfortran -ff2c"
endif

SETCFLAGS := CFLAGS='$(CFLAGS)' LDFLAGS='$(LDFLAGS)' CPPFLAGS='$(CPPFLAGS)'

# common configure options
archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-openmp --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

build-arch:
	dh_autoreconf
	# single precision
	$(SETCFLAGS) ./configure --enable-single $(archconfflags) $(archconfflags_single)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-single
	#
	# double precision
	$(SETCFLAGS) ./configure $(archconfflags) $(archconfflags_double)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-double
	# long double precision
ifeq (long,$(LONG))
	$(SETCFLAGS) ./configure --enable-long-double $(archconfflags)
	$(MAKE)
	( cd tests ; $(MAKE) smallcheck )
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-long;
endif
ifeq (quad,$(QUAD))
	# quad precision
	$(SETCFLAGS) ./configure $(archconfflags) --enable-quad-precision --disable-mpi
	$(MAKE)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd tests ; $(MAKE) smallcheck )
endif
	$(MAKE) install DESTDIR=`pwd`/debian/tmp-quad
endif
	touch build-arch

build-indep:
	-(cd doc ; $(MAKE) -j1 -k clean)
	-rm -f doc/*.info* doc/rfftwnd.png doc/html/*
	cd doc/FAQ && $(MAKE) -j1 fftw-faq.html fftw-faq.ascii
	cd doc && $(MAKE) -j1 && $(MAKE) -j1 html
	touch build-indep

build: build-stamp
build-stamp: build-arch

clean: clean1st
clean1st:
	dh_testdir
	dh_testroot
	rm -f build-arch build-indep
	(cd doc ; [ ! -f Makefile ] || $(MAKE) -k clean)
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -f *.la threads/*.la *.pc
	-rm -f test_long_long-double
	-rm -f config.cache config.status config.log
	-rm -rf debian/tmp-single debian/tmp-double debian/tmp-long debian/tmp-quad
	rm -f mpi/mpi-bench
	chmod -R g-s .
	dh_autoreconf_clean
	dh_clean

binary-indep: build-indep
	# build fftw3-doc
	dh_prep -i
	dh_testdir
	dh_testroot
	dh_installdocs -i README NEWS
	dh_installinfo -i
	dh_installchangelogs -i ChangeLog
	dh_compress -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i -- -Zxz

binary-arch: build-arch
	# build fftw3
	dh_prep -a
	dh_installdocs -a -A README NEWS debian/README.Debian
	dh_installchangelogs -a -XChangeLog
	dh_installexamples -a
	dh_installdirs -a
	set -e && for s in $(PREC); do \
	  dh_install -plibfftw3-bin --sourcedir=debian/tmp-$$s; \
	  dh_install -plibfftw3-$${s}3 --sourcedir=debian/tmp-$$s; \
	  dh_install -plibfftw3-dev --sourcedir=debian/tmp-$$s; \
	done

	find $(CURDIR)/debian/libfftw3-dev -type d -empty -delete

	dh_installman -a
	dh_strip --dbg-package=libfftw3-dbg -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a -- -Zxz

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean
.NOTPARALLEL:

=== debian/watch ===
version=3

opts=pasv ftp://ftp.fftw.org/pub/fftw/ fftw-([\.0-9]*)\.tar\.gz

## fftw3 3.3.4

=== debian/changelog ===
fftw3 (3.3.4-2ubuntu1) vivid; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Remove the mpi packages not suitable for main.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 02 Dec 2014 22:51:54 +0100

fftw3 (3.3.4-2) unstable; urgency=medium

  * Team upload.
  * fix-runtime-neon-detection.patch: new patch, fixes runtime NEON
    detection on armhf (and also arm64, but NEON is currently
    unconditionnally disabled there). Thanks to Edmund Grimley Evans for
    the patch. (Closes: #767138)

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 23 Nov 2014 20:49:59 +0100

fftw3 (3.3.4-1.1ubuntu1) vivid; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Remove the mpi packages not suitable for main.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 03 Nov 2014 12:49:12 +0100

fftw3 (3.3.4-1.1) unstable; urgency=low

  * Add mips64(el), ppc64el and arm64 to the list with long double support.
    (Closes: #763007)

 -- YunQiang Su <syq@debian.org>  Sat, 11 Oct 2014 17:26:31 +0800

fftw3 (3.3.4-1ubuntu1) utopic; urgency=medium

  * Merge with Debian unstable. Remaining Ubuntu changes:
    - Remove the mpi packages not suitable for main.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 25 Jul 2014 12:18:03 +0200

fftw3 (3.3.4-1) unstable; urgency=medium

  * New upstream release (Closes: #741851)
    - all patches applied upstream
  * add autopkgtest depend on build-essential (Closes: #740095)
  * Bump to standards 3.9.5, no changes required
  * suggest libfftw3-doc in -dev packages (Closes: #735541)
  * increase debian/compat to 9 and make -dbg package Multi-Arch: same
  * disable neon support on arm64, crashes currently available gcc 4.8.2

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sun, 16 Mar 2014 15:59:47 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Uploaders: Paul Brossier <piem@debian.org>,
            Julian Taylor <jtaylor.debian@googlemail.com>
 Build-Depends: chrpath,
-               debhelper (>=7.0.0),
+               debhelper (>= 9),
                dh-autoreconf,
                dpkg (>= 1.16.0),
                gfortran,
@@ -15,13 +15,13 @@
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/fftw3.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/fftw3.git
 Homepage: http://fftw.org
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 XS-Testsuite: autopkgtest
 
 Package: libfftw3-3
 Architecture: any
 Depends: libfftw3-double3 (=${binary:Version}),
-         libfftw3-long3 (=${binary:Version}) [amd64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe s390 s390x sparc x32],
+         libfftw3-long3 (=${binary:Version}) [amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el s390 s390x sparc x32],
          libfftw3-single3 (=${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
@@ -74,7 +74,7 @@
  libfftw3-dev. For documentation, see libfftw3-doc.
 
 Package: libfftw3-long3
-Architecture: amd64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe s390 s390x sparc x32
+Architecture: amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el s390 s390x sparc x32
 Pre-Depends: multiarch-support
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: libfftw3-bin, libfftw3-dev
@@ -125,6 +125,7 @@
          libfftw3-single3 (=${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
+Suggests: libfftw3-doc
 Provides: fftw3-dev
 Replaces: fftw3-dev
 Conflicts: fftw3-dev
@@ -155,6 +156,7 @@
 Section: debug
 Priority: extra
 Depends: libfftw3-dev (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
 Description: Library for computing Fast Fourier Transforms - debug symbols
  The FFTW library computes Fast Fourier Transforms (FFT) in one or more
  dimensions. It is extremely fast. This package contains the statically linked

=== debian/rules ===
--- 
+++ 
@@ -67,7 +67,7 @@
 SETCFLAGS := CFLAGS='$(CFLAGS)' LDFLAGS='$(LDFLAGS)' CPPFLAGS='$(CPPFLAGS)'
 
 # common configure options
-archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-openmp --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
+archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-openmp --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) MPILIBS="$(shell mpicc --showme:link)"
 
 build-arch:
 	dh_autoreconf

## fftw3 3.3.5

=== debian/changelog ===
fftw3 (3.3.5-3~bpo8+1) jessie-backports; urgency=medium

  * Straight backport, fixes NEON support on ARM on Jessie because of
    compiler flag differences.
  * Team upload.

 -- Steffen Moeller <moeller@debian.org>  Tue, 09 May 2017 23:34:36 +0200

fftw3 (3.3.5-3) unstable; urgency=medium

  * fix typo in shlibs file of last upload

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Fri, 06 Jan 2017 23:05:04 +0100

fftw3 (3.3.5-2) unstable; urgency=medium

  * add stricter shlib dependencies for partial upgrades (Closes: #849593)
  * mark libfft3-mpi-dev m-a same and libfftw3-doc m-a foreign

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Fri, 06 Jan 2017 18:44:49 +0100

fftw3 (3.3.5-1) unstable; urgency=medium

  * New upstream version 3.3.5
  * Update patch fix-runtime-neon-detection.patch.
  * Remove superfluous occurrences of ${shlibs:Depends}.
  * Insert multiarch support via ${misc:Pre-Depends}.
  * Add missing configure step in build-indep. (Closes: #806616)
  * Remove XS-Testsuite field, no longer required.
  * Use current canonical VCS URIs.
  * Bump standards version to 3.9.8, no changes required.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 03 Oct 2016 18:12:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: fftw3
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Paul Brossier <piem@debian.org>,
            Julian Taylor <jtaylor.debian@googlemail.com>
 Build-Depends: chrpath,
@@ -10,21 +9,20 @@
                dh-autoreconf,
                dpkg (>= 1.16.0),
                gfortran,
+               mpi-default-dev,
                texinfo
 Build-Depends-Indep: ghostscript (>> 8.63), transfig
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/fftw3.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/fftw3.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fftw3.git
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/fftw3.git
 Homepage: http://fftw.org
-Standards-Version: 3.9.5
-XS-Testsuite: autopkgtest
+Standards-Version: 3.9.8
 
 Package: libfftw3-3
 Architecture: any
 Depends: libfftw3-double3 (=${binary:Version}),
          libfftw3-long3 (=${binary:Version}) [amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el s390 s390x sparc x32],
          libfftw3-single3 (=${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
+         ${misc:Depends}
 Suggests: libfftw3-bin, libfftw3-dev
 Provides: fftw3
 Replaces: fftw3
@@ -43,7 +41,7 @@
 
 Package: libfftw3-single3
 Architecture: any
-Pre-Depends: multiarch-support
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: libfftw3-bin, libfftw3-dev
 Multi-Arch: same
@@ -59,7 +57,7 @@
 
 Package: libfftw3-double3
 Architecture: any
-Pre-Depends: multiarch-support
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: libfftw3-bin, libfftw3-dev
 Multi-Arch: same
@@ -75,7 +73,7 @@
 
 Package: libfftw3-long3
 Architecture: amd64 arm64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64 mips64el powerpc powerpcspe ppc64el s390 s390x sparc x32
-Pre-Depends: multiarch-support
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: libfftw3-bin, libfftw3-dev
 Multi-Arch: same
@@ -91,7 +89,7 @@
 
 Package: libfftw3-quad3
 Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 x32
-Pre-Depends: multiarch-support
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: libfftw3-bin, libfftw3-dev
 Multi-Arch: same
@@ -115,6 +113,22 @@
  .
  This package contains the wisdom management tools.
 
+Package: libfftw3-mpi3
+Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Suggests: libfftw3-mpi-dev
+Multi-Arch: same
+Description: MPI Library for computing Fast Fourier Transforms
+ The FFTW library computes Fast Fourier Transforms (FFT) in one or more
+ dimensions. It is extremely fast. This package contains the shared library
+ versions of the fftw libraries in single, double and long double precisions.
+ Note that on some architectures double is the same as long double in which
+ case there is no long double library.
+ .
+ To get the static library and the header files, you need to install
+ libfftw3-mpi-dev. For documentation, see libfftw3-doc.
+
 Package: libfftw3-dev
 Architecture: any
 Section: libdevel
@@ -123,8 +137,7 @@
          libfftw3-long3 (=${binary:Version}) [amd64 hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc powerpcspe s390 s390x sparc x32],
          libfftw3-quad3 (=${binary:Version}) [amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 x32],
          libfftw3-single3 (=${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
+         ${misc:Depends}
 Suggests: libfftw3-doc
 Provides: fftw3-dev
 Replaces: fftw3-dev
@@ -138,6 +151,20 @@
  This package contains the header files and static libraries.
  For documentation, see libfftw3-doc.
 
+Package: libfftw3-mpi-dev
+Architecture: any
+Section: libdevel
+Depends: libfftw3-mpi3 (=${binary:Version}), ${misc:Depends}
+Suggests: libfftw3-doc
+Multi-Arch: same
+Description: MPI Library for computing Fast Fourier Transforms - development
+ The FFTW library computes Fast Fourier Transforms (FFT) in one or more
+ dimensions. It is extremely fast. This package contains the statically linked
+ library, header files and test programs.
+ .
+ This package contains the header files and static libraries for the
+ mpi libraries. For documentation, see libfftw3-doc.
+
 Package: libfftw3-doc
 Architecture: all
 Section: doc
@@ -146,6 +173,7 @@
 Provides: fftw3-doc
 Replaces: fftw3-doc
 Conflicts: fftw3-doc
+Multi-Arch: foreign
 Description: Documentation for fftw version 3
  The FFTW library computes Fast Fourier Transforms (FFT) in one or more
  dimensions. It is extremely fast. This package contains the documentation for
@@ -155,13 +183,13 @@
 Architecture: any
 Section: debug
 Priority: extra
-Depends: libfftw3-dev (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libfftw3-dev (=${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: Library for computing Fast Fourier Transforms - debug symbols
  The FFTW library computes Fast Fourier Transforms (FFT) in one or more
  dimensions. It is extremely fast. This package contains the statically linked
  library, header files and test programs.
  .
- This package contains debug packages.
+ This package contains debug packages for both serial and MPI versions.
  .
  For documentation, see libfftw3-doc.

=== debian/rules ===
--- 
+++ 
@@ -67,7 +67,7 @@
 SETCFLAGS := CFLAGS='$(CFLAGS)' LDFLAGS='$(LDFLAGS)' CPPFLAGS='$(CPPFLAGS)'
 
 # common configure options
-archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-openmp --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) MPILIBS="$(shell mpicc --showme:link)"
+archconfflags := $(archconfflags) --prefix=/usr --enable-shared --enable-threads --enable-openmp --enable-mpi --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) MPILIBS="$(shell mpicc --showme:link)"
 
 build-arch:
 	dh_autoreconf
@@ -103,6 +103,7 @@
 build-indep:
 	-(cd doc ; $(MAKE) -j1 -k clean)
 	-rm -f doc/*.info* doc/rfftwnd.png doc/html/*
+	[ -f doc/Makefile ] || ./configure
 	cd doc/FAQ && $(MAKE) -j1 fftw-faq.html fftw-faq.ascii
 	cd doc && $(MAKE) -j1 && $(MAKE) -j1 html
 	touch build-indep
@@ -151,7 +152,15 @@
 	  dh_install -plibfftw3-bin --sourcedir=debian/tmp-$$s; \
 	  dh_install -plibfftw3-$${s}3 --sourcedir=debian/tmp-$$s; \
 	  dh_install -plibfftw3-dev --sourcedir=debian/tmp-$$s; \
+	  if [ $$s != "quad" ]; then \
+	    dh_install -plibfftw3-mpi3 --sourcedir=debian/tmp-$$s; \
+	    dh_install -plibfftw3-mpi-dev --sourcedir=debian/tmp-$$s; \
+	    rm debian/libfftw3-$${s}3/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi*; \
+	  fi; \
 	done
+	rm debian/libfftw3-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi* \
+	   debian/libfftw3-dev/usr/include/*mpi*
+	chrpath --delete debian/libfftw3-mpi3/usr/lib/$(DEB_HOST_MULTIARCH)/libfftw3*mpi*so*
 
 	find $(CURDIR)/debian/libfftw3-dev -type d -empty -delete
 
@@ -160,6 +169,10 @@
 	dh_compress -a
 	dh_fixperms -a
 	dh_makeshlibs -a
+	# 3.3.5 added new symbols, tighten shlibs for partial upgrades
+	set -e && for s in $(PREC); do \
+	  dh_makeshlibs -plibfftw3-$${s}3 -V "libfftw3-$${s}3 (>= 3.3.5)"; \
+	done
 	dh_installdeb -a
 	dh_shlibdeps -a
 	dh_gencontrol -a

## fftw3 3.3.6p2

=== debian/changelog ===
fftw3 (3.3.6p2-1) unstable; urgency=medium

  * Support NEON also for arm64 platform
  * ARM targets have --with-slow-timer enabled to avoid difficulties with
    erratic timers for planning and self-optimisation
  * Extend debian/watch to also recognize patchlevels
  * Team upload.

 -- Steffen Moeller <moeller@debian.org>  Wed, 10 May 2017 20:56:15 +0200

=== debian/watch ===
version=4

#opts=passive 
#opts="
opts="passive,uversionmangle=s/-pl/p/" ftp://ftp.fftw.org/pub/fftw/ fftw-([\.0-9]*-?pl?[0-9]?)\.tar\.gz

## fftw3 3.3.7

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)

if (NOT DEFINED CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project (fftw)

if (POLICY CMP0042)
  cmake_policy (SET CMP0042 NEW)
endif ()

option (BUILD_SHARED_LIBS "Build shared libraries" ON)
option (BUILD_TESTS "Build tests" ON)

option (ENABLE_OPENMP "Use OpenMP for multithreading" OFF)
option (ENABLE_THREADS "Use pthread for multithreading" OFF)
option (WITH_COMBINED_THREADS "Merge thread library" OFF)

option (ENABLE_FLOAT "single-precision" OFF)
option (ENABLE_LONG_DOUBLE "long-double precision" OFF)
option (ENABLE_QUAD_PRECISION "quadruple-precision" OFF)

option (ENABLE_SSE "Compile with SSE instruction set support" OFF)
option (ENABLE_SSE2 "Compile with SSE2 instruction set support" OFF)
option (ENABLE_AVX "Compile with AVX instruction set support" OFF)
option (ENABLE_AVX2 "Compile with AVX2 instruction set support" OFF)

include(GNUInstallDirs)


include (CheckIncludeFile)
check_include_file (alloca.h         HAVE_ALLOCA_H)
check_include_file (altivec.h        HAVE_ALTIVEC_H)
check_include_file (c_asm.h          HAVE_C_ASM_H)
check_include_file (intrinsics.h     HAVE_INTRINSICS_H)
check_include_file (inttypes.h       HAVE_INTTYPES_H)
check_include_file (libintl.h        HAVE_LIBINTL_H)
check_include_file (limits.h         HAVE_LIMITS_H)
check_include_file (mach/mach_time.h HAVE_MACH_MACH_TIME_H)
check_include_file (malloc.h         HAVE_MALLOC_H)
check_include_file (memory.h         HAVE_MEMORY_H)
check_include_file (stddef.h         HAVE_STDDEF_H)
check_include_file (stdint.h         HAVE_STDINT_H)
check_include_file (stdlib.h         HAVE_STDLIB_H)
check_include_file (string.h         HAVE_STRING_H)
check_include_file (strings.h        HAVE_STRINGS_H)
check_include_file (sys/types.h      HAVE_SYS_TYPES_H)
check_include_file (sys/time.h       HAVE_SYS_TIME_H)
check_include_file (sys/stat.h       HAVE_SYS_STAT_H)
check_include_file (sys/sysctl.h     HAVE_SYS_SYSCTL_H)
check_include_file (time.h           HAVE_TIME_H)
check_include_file (uintptr.h        HAVE_UINTPTR_H)
check_include_file (unistd.h         HAVE_UNISTD_H)
if (HAVE_TIME_H AND HAVE_SYS_TIME_H)
  set (TIME_WITH_SYS_TIME TRUE)
endif ()

include (CheckPrototypeDefinition) 
check_prototype_definition (drand48 "double drand48 (void)" "0" stdlib.h HAVE_DECL_DRAND48)
check_prototype_definition (srand48 "void srand48(long int seedval)" "0" stdlib.h HAVE_DECL_SRAND48)
check_prototype_definition (cosl "long double cosl( long double arg )" "0" math.h HAVE_DECL_COSL)
check_prototype_definition (sinl "long double sinl( long double arg )" "0" math.h HAVE_DECL_SINL)
check_prototype_definition (memalign "void *memalign(size_t alignment, size_t size)" "0" malloc.h HAVE_DECL_MEMALIGN)
check_prototype_definition (posix_memalign "int posix_memalign(void **memptr, size_t alignment, size_t size)" "0" stdlib.h HAVE_DECL_POSIX_MEMALIGN)

include (CheckSymbolExists)
check_symbol_exists (clock_gettime time.h HAVE_CLOCK_GETTIME)
check_symbol_exists (gettimeofday sys/time.h HAVE_GETTIMEOFDAY)
check_symbol_exists (drand48 stdlib.h HAVE_DRAND48)
check_symbol_exists (srand48 stdlib.h HAVE_SRAND48)
check_symbol_exists (memalign malloc.h HAVE_MEMALIGN)
check_symbol_exists (posix_memalign stdlib.h HAVE_POSIX_MEMALIGN)
check_symbol_exists (mach_absolute_time mach/mach_time.h HAVE_MACH_ABSOLUTE_TIME)
check_symbol_exists (alloca alloca.h HAVE_ALLOCA)
check_symbol_exists (isnan math.h HAVE_ISNAN)
check_symbol_exists (snprintf stdio.h HAVE_SNPRINTF)

if (UNIX)
  set (CMAKE_REQUIRED_LIBRARIES m)
endif ()
check_symbol_exists (cosl math.h HAVE_COSL)
check_symbol_exists (sinl math.h HAVE_SINL)

include (CheckTypeSize)
check_type_size ("float" SIZEOF_FLOAT)
check_type_size ("double" SIZEOF_DOUBLE)
check_type_size ("int" SIZEOF_INT)
check_type_size ("long" SIZEOF_LONG)
check_type_size ("long long" SIZEOF_LONG_LONG)
check_type_size ("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size ("unsigned long" SIZEOF_UNSIGNED_LONG)
check_type_size ("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)
check_type_size ("size_t" SIZEOF_SIZE_T)
check_type_size ("ptrdiff_t" SIZEOF_PTRDIFF_T)

if (UNIX)
  set (HAVE_LIBM TRUE)
endif ()


if (ENABLE_THREADS)
  find_package (Threads)
endif ()
if (Threads_FOUND)
  if(CMAKE_USE_PTHREADS_INIT)
    set (USING_POSIX_THREADS 1)
  endif ()
  set (HAVE_THREADS TRUE)
endif ()

if (ENABLE_OPENMP)
  find_package (OpenMP)
endif ()
if (OPENMP_FOUND)
  set (HAVE_OPENMP TRUE)
endif ()

include (CheckCCompilerFlag)

if (ENABLE_SSE)
  foreach (FLAG "-msse" "/arch:SSE")
    unset (HAVE_SSE CACHE)
    check_c_compiler_flag (${FLAG} HAVE_SSE)
    if (HAVE_SSE)
      set (SSE_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_SSE2)
  foreach (FLAG "-msse2" "/arch:SSE2")
    unset (HAVE_SSE2 CACHE)
    check_c_compiler_flag (${FLAG} HAVE_SSE2)
    if (HAVE_SSE2)
      set (SSE2_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_AVX)
  foreach (FLAG "-mavx" "/arch:AVX")
    unset (HAVE_AVX CACHE)
    check_c_compiler_flag (${FLAG} HAVE_AVX)
    if (HAVE_AVX)
      set (AVX_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (ENABLE_AVX2)
  foreach (FLAG "-mavx2" "/arch:AVX2")
    unset (HAVE_AVX2 CACHE)
    check_c_compiler_flag (${FLAG} HAVE_AVX2)
    if (HAVE_AVX2)
      set (AVX2_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

# AVX2 codelets require FMA support as well
if (ENABLE_AVX2)
  foreach (FLAG "-mfma" "/arch:FMA")
    unset (HAVE_FMA CACHE)
    check_c_compiler_flag (${FLAG} HAVE_FMA)
    if (HAVE_FMA)
      set (FMA_FLAG ${FLAG})
      break()
    endif ()
  endforeach ()
endif ()

if (HAVE_SSE2 OR HAVE_AVX)
  set (HAVE_SIMD TRUE)
endif ()
file(GLOB           fftw_api_SOURCE                 api/*.c             api/*.h)
file(GLOB           fftw_dft_SOURCE                 dft/*.c             dft/*.h)
file(GLOB           fftw_dft_scalar_SOURCE          dft/scalar/*.c      dft/scalar/*.h)
file(GLOB           fftw_dft_scalar_codelets_SOURCE dft/scalar/codelets/*.c     dft/scalar/codelets/*.h)
file(GLOB           fftw_dft_simd_SOURCE            dft/simd/*.c        dft/simd/*.h)

file(GLOB           fftw_dft_simd_sse2_SOURCE       dft/simd/sse2/*.c   dft/simd/sse2/*.h)
file(GLOB           fftw_dft_simd_avx_SOURCE        dft/simd/avx/*.c    dft/simd/avx/*.h)
file(GLOB           fftw_dft_simd_avx2_SOURCE       dft/simd/avx2/*.c   dft/simd/avx2/*.h dft/simd/avx2-128/*.c   dft/simd/avx2-128/*.h)
file(GLOB           fftw_kernel_SOURCE              kernel/*.c          kernel/*.h)
file(GLOB           fftw_rdft_SOURCE                rdft/*.c            rdft/*.h)
file(GLOB           fftw_rdft_scalar_SOURCE         rdft/scalar/*.c     rdft/scalar/*.h)

file(GLOB           fftw_rdft_scalar_r2cb_SOURCE    rdft/scalar/r2cb/*.c
                                                    rdft/scalar/r2cb/*.h)
file(GLOB           fftw_rdft_scalar_r2cf_SOURCE    rdft/scalar/r2cf/*.c
                                                    rdft/scalar/r2cf/*.h)
file(GLOB           fftw_rdft_scalar_r2r_SOURCE     rdft/scalar/r2r/*.c
                                                    rdft/scalar/r2r/*.h)

file(GLOB           fftw_rdft_simd_SOURCE           rdft/simd/*.c       rdft/simd/*.h)
file(GLOB           fftw_rdft_simd_sse2_SOURCE      rdft/simd/sse2/*.c  rdft/simd/sse2/*.h)
file(GLOB           fftw_rdft_simd_avx_SOURCE       rdft/simd/avx/*.c   rdft/simd/avx/*.h)
file(GLOB           fftw_rdft_simd_avx2_SOURCE      rdft/simd/avx2/*.c  rdft/simd/avx2/*.h rdft/simd/avx2-128/*.c  rdft/simd/avx2-128/*.h)

file(GLOB           fftw_reodft_SOURCE              reodft/*.c          reodft/*.h)
file(GLOB           fftw_simd_support_SOURCE        simd-support/*.c    simd-support/*.h)
file(GLOB           fftw_libbench2_SOURCE           libbench2/*.c       libbench2/*.h)
list (REMOVE_ITEM   fftw_libbench2_SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/libbench2/useropt.c)

set(SOURCEFILES
    ${fftw_api_SOURCE}
    ${fftw_dft_SOURCE}
    ${fftw_dft_scalar_SOURCE}
    ${fftw_dft_scalar_codelets_SOURCE}
    ${fftw_dft_simd_SOURCE}
    ${fftw_kernel_SOURCE}
    ${fftw_rdft_SOURCE}
    ${fftw_rdft_scalar_SOURCE}

    ${fftw_rdft_scalar_r2cb_SOURCE}
    ${fftw_rdft_scalar_r2cf_SOURCE}
    ${fftw_rdft_scalar_r2r_SOURCE}

    ${fftw_rdft_simd_SOURCE}
    ${fftw_reodft_SOURCE}
    ${fftw_simd_support_SOURCE}
    ${fftw_threads_SOURCE}
)

set(fftw_par_SOURCE
    threads/api.c
    threads/conf.c
    threads/ct.c
    threads/dft-vrank-geq1.c
    threads/f77api.c
    threads/hc2hc.c
    threads/rdft-vrank-geq1.c
    threads/vrank-geq1-rdft2.c)

set (fftw_threads_SOURCE ${fftw_par_SOURCE} threads/threads.c)
set (fftw_omp_SOURCE ${fftw_par_SOURCE} threads/openmp.c)


include_directories (.)


if (WITH_COMBINED_THREADS)
  list (APPEND SOURCEFILES ${fftw_threads_SOURCE})
endif ()


if (HAVE_SSE2)
  list (APPEND SOURCEFILES ${fftw_dft_simd_sse2_SOURCE} ${fftw_rdft_simd_sse2_SOURCE})
endif ()

if (HAVE_AVX)
  list (APPEND SOURCEFILES ${fftw_dft_simd_avx_SOURCE} ${fftw_rdft_simd_avx_SOURCE})
endif ()

if (HAVE_AVX2)
  list (APPEND SOURCEFILES ${fftw_dft_simd_avx2_SOURCE} ${fftw_rdft_simd_avx2_SOURCE})
endif ()

set (FFTW_VERSION 3.3.7)

set (PREC_SUFFIX)
if (ENABLE_FLOAT)
  set (FFTW_SINGLE TRUE)
  set (BENCHFFT_SINGLE TRUE)
  set (PREC_SUFFIX f)
endif ()

if (ENABLE_LONG_DOUBLE)
  set (FFTW_LDOUBLE TRUE)
  set (BENCHFFT_LDOUBLE TRUE)
  set (PREC_SUFFIX l)
endif ()

if (ENABLE_QUAD_PRECISION)
  set (FFTW_QUAD TRUE)
  set (BENCHFFT_QUAD TRUE)
  set (PREC_SUFFIX q)
endif ()
set (fftw3_lib fftw3${PREC_SUFFIX})

configure_file (cmake.config.h.in config.h @ONLY)
include_directories (${CMAKE_CURRENT_BINARY_DIR})

if (BUILD_SHARED_LIBS)
  add_definitions (-DFFTW_DLL)
endif ()


add_library (${fftw3_lib} ${SOURCEFILES})
if (MSVC)
  target_compile_definitions (${fftw3_lib} PRIVATE /bigobj)
endif ()
if (HAVE_SSE)
  target_compile_options (${fftw3_lib} PRIVATE ${SSE_FLAG})
endif ()
if (HAVE_SSE2)
  target_compile_options (${fftw3_lib} PRIVATE ${SSE2_FLAG})
endif ()
if (HAVE_AVX)
  target_compile_options (${fftw3_lib} PRIVATE ${AVX_FLAG})
endif ()
if (HAVE_AVX2)
  target_compile_options (${fftw3_lib} PRIVATE ${AVX2_FLAG})
endif ()
if (HAVE_FMA)
  target_compile_options (${fftw3_lib} PRIVATE ${FMA_FLAG})
endif ()
if (HAVE_LIBM)
  target_link_libraries (${fftw3_lib} m)
endif ()

set (subtargets ${fftw3_lib})

if (Threads_FOUND)
  if (WITH_COMBINED_THREADS)
    target_link_libraries (${fftw3_lib} ${CMAKE_THREAD_LIBS_INIT})
  else ()
    add_library (${fftw3_lib}_threads ${fftw_threads_SOURCE})
    target_link_libraries (${fftw3_lib}_threads ${fftw3_lib})
    target_link_libraries (${fftw3_lib}_threads ${CMAKE_THREAD_LIBS_INIT})
    list (APPEND subtargets ${fftw3_lib}_threads)
  endif ()
endif ()

if (OPENMP_FOUND)
  add_library (${fftw3_lib}_omp ${fftw_omp_SOURCE})
  target_link_libraries (${fftw3_lib}_omp ${fftw3_lib})
  target_link_libraries (${fftw3_lib}_omp ${CMAKE_THREAD_LIBS_INIT})
  list (APPEND subtargets ${fftw3_lib}_omp)
  target_compile_options (${fftw3_lib}_omp PRIVATE ${OpenMP_C_FLAGS})
endif ()

foreach(subtarget ${subtargets})
  set_target_properties (${subtarget} PROPERTIES SOVERSION 3.5.7 VERSION 3)
  install (TARGETS ${subtarget}
	  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endforeach ()
install(TARGETS ${fftw3_lib}
          EXPORT FFTW3LibraryDepends
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

install (FILES api/fftw3.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
if (EXISTS api/fftw3.f)
  install (FILES api/fftw3.f DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
endif ()

if (BUILD_TESTS)

  add_executable (bench ${fftw_libbench2_SOURCE} tests/bench.c tests/hook.c tests/fftw-bench.c)

=== debian/changelog ===
fftw3 (3.3.7-1) unstable; urgency=medium

  * Team upload.

  * debian/watch: New upstream version and fix to debian/watch to find it
  * debian/control: Updated policy to 4.1.2 - no changes required

 -- Steffen Moeller <moeller@debian.org>  Sat, 09 Dec 2017 22:15:58 +0100

fftw3 (3.3.6p2-2) unstable; urgency=medium

  * debian/patches/reproducible_build.patch: include patch from Reiner
    Herrmann to improve reproducibility (closes: #796324)
  * debian/control: bump standards-version to 4.0.0

 -- Paul Brossier <piem@debian.org>  Mon, 21 Aug 2017 16:41:11 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fftw3.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/fftw3.git
 Homepage: http://fftw.org
-Standards-Version: 3.9.8
+Standards-Version: 4.1.2
 
 Package: libfftw3-3
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -53,8 +53,8 @@
 ifeq ($(ARCHITECTURE), powerpc)
 	archconfflags_single := --enable-altivec
 endif
-ifneq (,$(filter $(ARCHITECTURE), armhf))
-	archconfflags_single := --enable-neon
+ifneq (,$(filter $(ARCHITECTURE), armhf arm64))
+	archconfflags_single := --enable-neon --with-slow-timer
 endif
 endif
 
@@ -118,7 +118,8 @@
 	rm -f build-arch build-indep
 	(cd doc ; [ ! -f Makefile ] || $(MAKE) -k clean)
 	[ ! -f Makefile ] || $(MAKE) distclean
-	-rm -f *.la threads/*.la *.pc
+	-rm -f *.pc tools/*wisdom tools/*wisdom.1
+	-find . -name "*.la" | xargs -r rm -f
 	-rm -f test_long_long-double
 	-rm -f config.cache config.status config.log
 	-rm -rf debian/tmp-single debian/tmp-double debian/tmp-long debian/tmp-quad

=== debian/watch ===
version=4

# circumventing an apparent uscan but that introduces an extra "." or the non-matching (-pl[0-9]+)?)
opts="passive,uversionmangle=s/-pl/p/,uversionmangle=s/.$//" ftp://ftp.fftw.org/pub/fftw/ fftw-([\.0-9]+(-pl[0-9]+)?).tar\.gz
